Update a subscription
curl --request PUT \
--url https://core.nozle.app/api/v1/subscriptions/{external_id} \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"subscription": {
"ending_at": "2022-10-08T00:00:00Z",
"name": "Repository B",
"subscription_at": "2022-08-08T00:00:00Z",
"plan_overrides": {
"amount_cents": 10000,
"amount_currency": "USD",
"description": "Plan for early stage startups.",
"invoice_display_name": "Startup plan",
"name": "Startup",
"tax_codes": [
"french_standard_vat"
],
"trial_period": 5,
"minimum_commitment": {
"amount_cents": 100000,
"invoice_display_name": "Minimum Commitment (C1)",
"tax_codes": [
"french_standard_vat"
]
},
"charges": [
{
"id": "1a901a90-1a90-1a90-1a90-1a901a901a90",
"feature_id": "1a901a90-1a90-1a90-1a90-1a901a901a90",
"code": "api_requests_charge",
"invoice_display_name": "Setup",
"min_amount_cents": 0,
"properties": {
"grouped_by": [
"agent_name"
],
"pricing_group_keys": [
"agent_name"
],
"graduated_ranges": [
{
"from_value": 0,
"to_value": 10,
"flat_amount": "10",
"per_unit_amount": "0.5"
}
],
"graduated_percentage_ranges": [
{
"from_value": 0,
"to_value": 10,
"rate": "1",
"flat_amount": "10"
}
],
"amount": "30",
"free_units": 100,
"package_size": 1000,
"rate": "1",
"fixed_amount": "0.5",
"free_units_per_events": 5,
"free_units_per_total_aggregation": "500",
"per_transaction_max_amount": "3.75",
"per_transaction_min_amount": "1.75",
"volume_ranges": [
{
"from_value": 0,
"to_value": 10,
"flat_amount": "10",
"per_unit_amount": "0.5"
}
],
"presentation_group_keys": [
{
"value": "region",
"options": {
"display_in_invoice": true
}
}
]
},
"filters": [
{
"properties": {
"grouped_by": [
"agent_name"
],
"pricing_group_keys": [
"agent_name"
],
"graduated_ranges": [
{
"from_value": 0,
"to_value": 10,
"flat_amount": "10",
"per_unit_amount": "0.5"
}
],
"graduated_percentage_ranges": [
{
"from_value": 0,
"to_value": 10,
"rate": "1",
"flat_amount": "10"
}
],
"amount": "30",
"free_units": 100,
"package_size": 1000,
"rate": "1",
"fixed_amount": "0.5",
"free_units_per_events": 5,
"free_units_per_total_aggregation": "500",
"per_transaction_max_amount": "3.75",
"per_transaction_min_amount": "1.75",
"volume_ranges": [
{
"from_value": 0,
"to_value": 10,
"flat_amount": "10",
"per_unit_amount": "0.5"
}
]
},
"values": {
"region": [
"us-east-1"
]
},
"invoice_display_name": "AWS"
}
],
"tax_codes": [
"french_standard_vat"
],
"applied_pricing_unit": {
"conversion_rate": "0.5"
}
}
],
"fixed_charges": [
{
"id": "1a901a90-1a90-1a90-1a90-1a901a901a90",
"invoice_display_name": "Setup fee",
"units": 1,
"apply_units_immediately": true,
"properties": {
"amount": "30",
"graduated_ranges": [
{
"from_value": 0,
"to_value": 10,
"flat_amount": "10",
"per_unit_amount": "0.5"
}
],
"volume_ranges": [
{
"from_value": 0,
"to_value": 10,
"flat_amount": "10",
"per_unit_amount": "0.5"
}
]
},
"tax_codes": [
"french_standard_vat"
]
}
],
"usage_thresholds": [
{
"amount_cents": 10000,
"threshold_display_name": "Threshold 1",
"recurring": true
}
],
"metadata": {
"external_id": "ext-123",
"synced_at": "2024-01-15"
}
},
"invoice_custom_section": {
"skip_invoice_custom_sections": false,
"invoice_custom_section_codes": [
"eu_bank_details"
]
},
"payment_method": {
"payment_method_type": "provider",
"payment_method_id": "1a901a90-1a90-1a90-1a90-1a901a901a90"
},
"consolidate_invoice": false,
"billing_entity_code": "default",
"activation_rules": [
{
"type": "payment",
"timeout_hours": 48
}
]
},
"status": "active"
}
'import requests
url = "https://core.nozle.app/api/v1/subscriptions/{external_id}"
payload = {
"subscription": {
"ending_at": "2022-10-08T00:00:00Z",
"name": "Repository B",
"subscription_at": "2022-08-08T00:00:00Z",
"plan_overrides": {
"amount_cents": 10000,
"amount_currency": "USD",
"description": "Plan for early stage startups.",
"invoice_display_name": "Startup plan",
"name": "Startup",
"tax_codes": ["french_standard_vat"],
"trial_period": 5,
"minimum_commitment": {
"amount_cents": 100000,
"invoice_display_name": "Minimum Commitment (C1)",
"tax_codes": ["french_standard_vat"]
},
"charges": [
{
"id": "1a901a90-1a90-1a90-1a90-1a901a901a90",
"feature_id": "1a901a90-1a90-1a90-1a90-1a901a901a90",
"code": "api_requests_charge",
"invoice_display_name": "Setup",
"min_amount_cents": 0,
"properties": {
"grouped_by": ["agent_name"],
"pricing_group_keys": ["agent_name"],
"graduated_ranges": [
{
"from_value": 0,
"to_value": 10,
"flat_amount": "10",
"per_unit_amount": "0.5"
}
],
"graduated_percentage_ranges": [
{
"from_value": 0,
"to_value": 10,
"rate": "1",
"flat_amount": "10"
}
],
"amount": "30",
"free_units": 100,
"package_size": 1000,
"rate": "1",
"fixed_amount": "0.5",
"free_units_per_events": 5,
"free_units_per_total_aggregation": "500",
"per_transaction_max_amount": "3.75",
"per_transaction_min_amount": "1.75",
"volume_ranges": [
{
"from_value": 0,
"to_value": 10,
"flat_amount": "10",
"per_unit_amount": "0.5"
}
],
"presentation_group_keys": [
{
"value": "region",
"options": { "display_in_invoice": True }
}
]
},
"filters": [
{
"properties": {
"grouped_by": ["agent_name"],
"pricing_group_keys": ["agent_name"],
"graduated_ranges": [
{
"from_value": 0,
"to_value": 10,
"flat_amount": "10",
"per_unit_amount": "0.5"
}
],
"graduated_percentage_ranges": [
{
"from_value": 0,
"to_value": 10,
"rate": "1",
"flat_amount": "10"
}
],
"amount": "30",
"free_units": 100,
"package_size": 1000,
"rate": "1",
"fixed_amount": "0.5",
"free_units_per_events": 5,
"free_units_per_total_aggregation": "500",
"per_transaction_max_amount": "3.75",
"per_transaction_min_amount": "1.75",
"volume_ranges": [
{
"from_value": 0,
"to_value": 10,
"flat_amount": "10",
"per_unit_amount": "0.5"
}
]
},
"values": { "region": ["us-east-1"] },
"invoice_display_name": "AWS"
}
],
"tax_codes": ["french_standard_vat"],
"applied_pricing_unit": { "conversion_rate": "0.5" }
}
],
"fixed_charges": [
{
"id": "1a901a90-1a90-1a90-1a90-1a901a901a90",
"invoice_display_name": "Setup fee",
"units": 1,
"apply_units_immediately": True,
"properties": {
"amount": "30",
"graduated_ranges": [
{
"from_value": 0,
"to_value": 10,
"flat_amount": "10",
"per_unit_amount": "0.5"
}
],
"volume_ranges": [
{
"from_value": 0,
"to_value": 10,
"flat_amount": "10",
"per_unit_amount": "0.5"
}
]
},
"tax_codes": ["french_standard_vat"]
}
],
"usage_thresholds": [
{
"amount_cents": 10000,
"threshold_display_name": "Threshold 1",
"recurring": True
}
],
"metadata": {
"external_id": "ext-123",
"synced_at": "2024-01-15"
}
},
"invoice_custom_section": {
"skip_invoice_custom_sections": False,
"invoice_custom_section_codes": ["eu_bank_details"]
},
"payment_method": {
"payment_method_type": "provider",
"payment_method_id": "1a901a90-1a90-1a90-1a90-1a901a901a90"
},
"consolidate_invoice": False,
"billing_entity_code": "default",
"activation_rules": [
{
"type": "payment",
"timeout_hours": 48
}
]
},
"status": "active"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
subscription: {
ending_at: '2022-10-08T00:00:00Z',
name: 'Repository B',
subscription_at: '2022-08-08T00:00:00Z',
plan_overrides: {
amount_cents: 10000,
amount_currency: 'USD',
description: 'Plan for early stage startups.',
invoice_display_name: 'Startup plan',
name: 'Startup',
tax_codes: ['french_standard_vat'],
trial_period: 5,
minimum_commitment: {
amount_cents: 100000,
invoice_display_name: 'Minimum Commitment (C1)',
tax_codes: ['french_standard_vat']
},
charges: [
{
id: '1a901a90-1a90-1a90-1a90-1a901a901a90',
feature_id: '1a901a90-1a90-1a90-1a90-1a901a901a90',
code: 'api_requests_charge',
invoice_display_name: 'Setup',
min_amount_cents: 0,
properties: {
grouped_by: ['agent_name'],
pricing_group_keys: ['agent_name'],
graduated_ranges: [{from_value: 0, to_value: 10, flat_amount: '10', per_unit_amount: '0.5'}],
graduated_percentage_ranges: [{from_value: 0, to_value: 10, rate: '1', flat_amount: '10'}],
amount: '30',
free_units: 100,
package_size: 1000,
rate: '1',
fixed_amount: '0.5',
free_units_per_events: 5,
free_units_per_total_aggregation: '500',
per_transaction_max_amount: '3.75',
per_transaction_min_amount: '1.75',
volume_ranges: [{from_value: 0, to_value: 10, flat_amount: '10', per_unit_amount: '0.5'}],
presentation_group_keys: [{value: 'region', options: {display_in_invoice: true}}]
},
filters: [
{
properties: {
grouped_by: ['agent_name'],
pricing_group_keys: ['agent_name'],
graduated_ranges: [{from_value: 0, to_value: 10, flat_amount: '10', per_unit_amount: '0.5'}],
graduated_percentage_ranges: [{from_value: 0, to_value: 10, rate: '1', flat_amount: '10'}],
amount: '30',
free_units: 100,
package_size: 1000,
rate: '1',
fixed_amount: '0.5',
free_units_per_events: 5,
free_units_per_total_aggregation: '500',
per_transaction_max_amount: '3.75',
per_transaction_min_amount: '1.75',
volume_ranges: [{from_value: 0, to_value: 10, flat_amount: '10', per_unit_amount: '0.5'}]
},
values: {region: ['us-east-1']},
invoice_display_name: 'AWS'
}
],
tax_codes: ['french_standard_vat'],
applied_pricing_unit: {conversion_rate: '0.5'}
}
],
fixed_charges: [
{
id: '1a901a90-1a90-1a90-1a90-1a901a901a90',
invoice_display_name: 'Setup fee',
units: 1,
apply_units_immediately: true,
properties: {
amount: '30',
graduated_ranges: [{from_value: 0, to_value: 10, flat_amount: '10', per_unit_amount: '0.5'}],
volume_ranges: [{from_value: 0, to_value: 10, flat_amount: '10', per_unit_amount: '0.5'}]
},
tax_codes: ['french_standard_vat']
}
],
usage_thresholds: [{amount_cents: 10000, threshold_display_name: 'Threshold 1', recurring: true}],
metadata: {external_id: 'ext-123', synced_at: '2024-01-15'}
},
invoice_custom_section: {
skip_invoice_custom_sections: false,
invoice_custom_section_codes: ['eu_bank_details']
},
payment_method: {
payment_method_type: 'provider',
payment_method_id: '1a901a90-1a90-1a90-1a90-1a901a901a90'
},
consolidate_invoice: false,
billing_entity_code: 'default',
activation_rules: [{type: 'payment', timeout_hours: 48}]
},
status: 'active'
})
};
fetch('https://core.nozle.app/api/v1/subscriptions/{external_id}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://core.nozle.app/api/v1/subscriptions/{external_id}"
payload := strings.NewReader("{\n \"subscription\": {\n \"ending_at\": \"2022-10-08T00:00:00Z\",\n \"name\": \"Repository B\",\n \"subscription_at\": \"2022-08-08T00:00:00Z\",\n \"plan_overrides\": {\n \"amount_cents\": 10000,\n \"amount_currency\": \"USD\",\n \"description\": \"Plan for early stage startups.\",\n \"invoice_display_name\": \"Startup plan\",\n \"name\": \"Startup\",\n \"tax_codes\": [\n \"french_standard_vat\"\n ],\n \"trial_period\": 5,\n \"minimum_commitment\": {\n \"amount_cents\": 100000,\n \"invoice_display_name\": \"Minimum Commitment (C1)\",\n \"tax_codes\": [\n \"french_standard_vat\"\n ]\n },\n \"charges\": [\n {\n \"id\": \"1a901a90-1a90-1a90-1a90-1a901a901a90\",\n \"feature_id\": \"1a901a90-1a90-1a90-1a90-1a901a901a90\",\n \"code\": \"api_requests_charge\",\n \"invoice_display_name\": \"Setup\",\n \"min_amount_cents\": 0,\n \"properties\": {\n \"grouped_by\": [\n \"agent_name\"\n ],\n \"pricing_group_keys\": [\n \"agent_name\"\n ],\n \"graduated_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ],\n \"graduated_percentage_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"rate\": \"1\",\n \"flat_amount\": \"10\"\n }\n ],\n \"amount\": \"30\",\n \"free_units\": 100,\n \"package_size\": 1000,\n \"rate\": \"1\",\n \"fixed_amount\": \"0.5\",\n \"free_units_per_events\": 5,\n \"free_units_per_total_aggregation\": \"500\",\n \"per_transaction_max_amount\": \"3.75\",\n \"per_transaction_min_amount\": \"1.75\",\n \"volume_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ],\n \"presentation_group_keys\": [\n {\n \"value\": \"region\",\n \"options\": {\n \"display_in_invoice\": true\n }\n }\n ]\n },\n \"filters\": [\n {\n \"properties\": {\n \"grouped_by\": [\n \"agent_name\"\n ],\n \"pricing_group_keys\": [\n \"agent_name\"\n ],\n \"graduated_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ],\n \"graduated_percentage_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"rate\": \"1\",\n \"flat_amount\": \"10\"\n }\n ],\n \"amount\": \"30\",\n \"free_units\": 100,\n \"package_size\": 1000,\n \"rate\": \"1\",\n \"fixed_amount\": \"0.5\",\n \"free_units_per_events\": 5,\n \"free_units_per_total_aggregation\": \"500\",\n \"per_transaction_max_amount\": \"3.75\",\n \"per_transaction_min_amount\": \"1.75\",\n \"volume_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ]\n },\n \"values\": {\n \"region\": [\n \"us-east-1\"\n ]\n },\n \"invoice_display_name\": \"AWS\"\n }\n ],\n \"tax_codes\": [\n \"french_standard_vat\"\n ],\n \"applied_pricing_unit\": {\n \"conversion_rate\": \"0.5\"\n }\n }\n ],\n \"fixed_charges\": [\n {\n \"id\": \"1a901a90-1a90-1a90-1a90-1a901a901a90\",\n \"invoice_display_name\": \"Setup fee\",\n \"units\": 1,\n \"apply_units_immediately\": true,\n \"properties\": {\n \"amount\": \"30\",\n \"graduated_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ],\n \"volume_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ]\n },\n \"tax_codes\": [\n \"french_standard_vat\"\n ]\n }\n ],\n \"usage_thresholds\": [\n {\n \"amount_cents\": 10000,\n \"threshold_display_name\": \"Threshold 1\",\n \"recurring\": true\n }\n ],\n \"metadata\": {\n \"external_id\": \"ext-123\",\n \"synced_at\": \"2024-01-15\"\n }\n },\n \"invoice_custom_section\": {\n \"skip_invoice_custom_sections\": false,\n \"invoice_custom_section_codes\": [\n \"eu_bank_details\"\n ]\n },\n \"payment_method\": {\n \"payment_method_type\": \"provider\",\n \"payment_method_id\": \"1a901a90-1a90-1a90-1a90-1a901a901a90\"\n },\n \"consolidate_invoice\": false,\n \"billing_entity_code\": \"default\",\n \"activation_rules\": [\n {\n \"type\": \"payment\",\n \"timeout_hours\": 48\n }\n ]\n },\n \"status\": \"active\"\n}")
req, _ := http.NewRequest("PUT", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}require 'uri'
require 'net/http'
url = URI("https://core.nozle.app/api/v1/subscriptions/{external_id}")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"subscription\": {\n \"ending_at\": \"2022-10-08T00:00:00Z\",\n \"name\": \"Repository B\",\n \"subscription_at\": \"2022-08-08T00:00:00Z\",\n \"plan_overrides\": {\n \"amount_cents\": 10000,\n \"amount_currency\": \"USD\",\n \"description\": \"Plan for early stage startups.\",\n \"invoice_display_name\": \"Startup plan\",\n \"name\": \"Startup\",\n \"tax_codes\": [\n \"french_standard_vat\"\n ],\n \"trial_period\": 5,\n \"minimum_commitment\": {\n \"amount_cents\": 100000,\n \"invoice_display_name\": \"Minimum Commitment (C1)\",\n \"tax_codes\": [\n \"french_standard_vat\"\n ]\n },\n \"charges\": [\n {\n \"id\": \"1a901a90-1a90-1a90-1a90-1a901a901a90\",\n \"feature_id\": \"1a901a90-1a90-1a90-1a90-1a901a901a90\",\n \"code\": \"api_requests_charge\",\n \"invoice_display_name\": \"Setup\",\n \"min_amount_cents\": 0,\n \"properties\": {\n \"grouped_by\": [\n \"agent_name\"\n ],\n \"pricing_group_keys\": [\n \"agent_name\"\n ],\n \"graduated_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ],\n \"graduated_percentage_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"rate\": \"1\",\n \"flat_amount\": \"10\"\n }\n ],\n \"amount\": \"30\",\n \"free_units\": 100,\n \"package_size\": 1000,\n \"rate\": \"1\",\n \"fixed_amount\": \"0.5\",\n \"free_units_per_events\": 5,\n \"free_units_per_total_aggregation\": \"500\",\n \"per_transaction_max_amount\": \"3.75\",\n \"per_transaction_min_amount\": \"1.75\",\n \"volume_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ],\n \"presentation_group_keys\": [\n {\n \"value\": \"region\",\n \"options\": {\n \"display_in_invoice\": true\n }\n }\n ]\n },\n \"filters\": [\n {\n \"properties\": {\n \"grouped_by\": [\n \"agent_name\"\n ],\n \"pricing_group_keys\": [\n \"agent_name\"\n ],\n \"graduated_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ],\n \"graduated_percentage_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"rate\": \"1\",\n \"flat_amount\": \"10\"\n }\n ],\n \"amount\": \"30\",\n \"free_units\": 100,\n \"package_size\": 1000,\n \"rate\": \"1\",\n \"fixed_amount\": \"0.5\",\n \"free_units_per_events\": 5,\n \"free_units_per_total_aggregation\": \"500\",\n \"per_transaction_max_amount\": \"3.75\",\n \"per_transaction_min_amount\": \"1.75\",\n \"volume_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ]\n },\n \"values\": {\n \"region\": [\n \"us-east-1\"\n ]\n },\n \"invoice_display_name\": \"AWS\"\n }\n ],\n \"tax_codes\": [\n \"french_standard_vat\"\n ],\n \"applied_pricing_unit\": {\n \"conversion_rate\": \"0.5\"\n }\n }\n ],\n \"fixed_charges\": [\n {\n \"id\": \"1a901a90-1a90-1a90-1a90-1a901a901a90\",\n \"invoice_display_name\": \"Setup fee\",\n \"units\": 1,\n \"apply_units_immediately\": true,\n \"properties\": {\n \"amount\": \"30\",\n \"graduated_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ],\n \"volume_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ]\n },\n \"tax_codes\": [\n \"french_standard_vat\"\n ]\n }\n ],\n \"usage_thresholds\": [\n {\n \"amount_cents\": 10000,\n \"threshold_display_name\": \"Threshold 1\",\n \"recurring\": true\n }\n ],\n \"metadata\": {\n \"external_id\": \"ext-123\",\n \"synced_at\": \"2024-01-15\"\n }\n },\n \"invoice_custom_section\": {\n \"skip_invoice_custom_sections\": false,\n \"invoice_custom_section_codes\": [\n \"eu_bank_details\"\n ]\n },\n \"payment_method\": {\n \"payment_method_type\": \"provider\",\n \"payment_method_id\": \"1a901a90-1a90-1a90-1a90-1a901a901a90\"\n },\n \"consolidate_invoice\": false,\n \"billing_entity_code\": \"default\",\n \"activation_rules\": [\n {\n \"type\": \"payment\",\n \"timeout_hours\": 48\n }\n ]\n },\n \"status\": \"active\"\n}"
response = http.request(request)
puts response.read_body<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://core.nozle.app/api/v1/subscriptions/{external_id}",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "PUT",
CURLOPT_POSTFIELDS => json_encode([
'subscription' => [
'ending_at' => '2022-10-08T00:00:00Z',
'name' => 'Repository B',
'subscription_at' => '2022-08-08T00:00:00Z',
'plan_overrides' => [
'amount_cents' => 10000,
'amount_currency' => 'USD',
'description' => 'Plan for early stage startups.',
'invoice_display_name' => 'Startup plan',
'name' => 'Startup',
'tax_codes' => [
'french_standard_vat'
],
'trial_period' => 5,
'minimum_commitment' => [
'amount_cents' => 100000,
'invoice_display_name' => 'Minimum Commitment (C1)',
'tax_codes' => [
'french_standard_vat'
]
],
'charges' => [
[
'id' => '1a901a90-1a90-1a90-1a90-1a901a901a90',
'feature_id' => '1a901a90-1a90-1a90-1a90-1a901a901a90',
'code' => 'api_requests_charge',
'invoice_display_name' => 'Setup',
'min_amount_cents' => 0,
'properties' => [
'grouped_by' => [
'agent_name'
],
'pricing_group_keys' => [
'agent_name'
],
'graduated_ranges' => [
[
'from_value' => 0,
'to_value' => 10,
'flat_amount' => '10',
'per_unit_amount' => '0.5'
]
],
'graduated_percentage_ranges' => [
[
'from_value' => 0,
'to_value' => 10,
'rate' => '1',
'flat_amount' => '10'
]
],
'amount' => '30',
'free_units' => 100,
'package_size' => 1000,
'rate' => '1',
'fixed_amount' => '0.5',
'free_units_per_events' => 5,
'free_units_per_total_aggregation' => '500',
'per_transaction_max_amount' => '3.75',
'per_transaction_min_amount' => '1.75',
'volume_ranges' => [
[
'from_value' => 0,
'to_value' => 10,
'flat_amount' => '10',
'per_unit_amount' => '0.5'
]
],
'presentation_group_keys' => [
[
'value' => 'region',
'options' => [
'display_in_invoice' => true
]
]
]
],
'filters' => [
[
'properties' => [
'grouped_by' => [
'agent_name'
],
'pricing_group_keys' => [
'agent_name'
],
'graduated_ranges' => [
[
'from_value' => 0,
'to_value' => 10,
'flat_amount' => '10',
'per_unit_amount' => '0.5'
]
],
'graduated_percentage_ranges' => [
[
'from_value' => 0,
'to_value' => 10,
'rate' => '1',
'flat_amount' => '10'
]
],
'amount' => '30',
'free_units' => 100,
'package_size' => 1000,
'rate' => '1',
'fixed_amount' => '0.5',
'free_units_per_events' => 5,
'free_units_per_total_aggregation' => '500',
'per_transaction_max_amount' => '3.75',
'per_transaction_min_amount' => '1.75',
'volume_ranges' => [
[
'from_value' => 0,
'to_value' => 10,
'flat_amount' => '10',
'per_unit_amount' => '0.5'
]
]
],
'values' => [
'region' => [
'us-east-1'
]
],
'invoice_display_name' => 'AWS'
]
],
'tax_codes' => [
'french_standard_vat'
],
'applied_pricing_unit' => [
'conversion_rate' => '0.5'
]
]
],
'fixed_charges' => [
[
'id' => '1a901a90-1a90-1a90-1a90-1a901a901a90',
'invoice_display_name' => 'Setup fee',
'units' => 1,
'apply_units_immediately' => true,
'properties' => [
'amount' => '30',
'graduated_ranges' => [
[
'from_value' => 0,
'to_value' => 10,
'flat_amount' => '10',
'per_unit_amount' => '0.5'
]
],
'volume_ranges' => [
[
'from_value' => 0,
'to_value' => 10,
'flat_amount' => '10',
'per_unit_amount' => '0.5'
]
]
],
'tax_codes' => [
'french_standard_vat'
]
]
],
'usage_thresholds' => [
[
'amount_cents' => 10000,
'threshold_display_name' => 'Threshold 1',
'recurring' => true
]
],
'metadata' => [
'external_id' => 'ext-123',
'synced_at' => '2024-01-15'
]
],
'invoice_custom_section' => [
'skip_invoice_custom_sections' => false,
'invoice_custom_section_codes' => [
'eu_bank_details'
]
],
'payment_method' => [
'payment_method_type' => 'provider',
'payment_method_id' => '1a901a90-1a90-1a90-1a90-1a901a901a90'
],
'consolidate_invoice' => false,
'billing_entity_code' => 'default',
'activation_rules' => [
[
'type' => 'payment',
'timeout_hours' => 48
]
]
],
'status' => 'active'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}HttpResponse<String> response = Unirest.put("https://core.nozle.app/api/v1/subscriptions/{external_id}")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"subscription\": {\n \"ending_at\": \"2022-10-08T00:00:00Z\",\n \"name\": \"Repository B\",\n \"subscription_at\": \"2022-08-08T00:00:00Z\",\n \"plan_overrides\": {\n \"amount_cents\": 10000,\n \"amount_currency\": \"USD\",\n \"description\": \"Plan for early stage startups.\",\n \"invoice_display_name\": \"Startup plan\",\n \"name\": \"Startup\",\n \"tax_codes\": [\n \"french_standard_vat\"\n ],\n \"trial_period\": 5,\n \"minimum_commitment\": {\n \"amount_cents\": 100000,\n \"invoice_display_name\": \"Minimum Commitment (C1)\",\n \"tax_codes\": [\n \"french_standard_vat\"\n ]\n },\n \"charges\": [\n {\n \"id\": \"1a901a90-1a90-1a90-1a90-1a901a901a90\",\n \"feature_id\": \"1a901a90-1a90-1a90-1a90-1a901a901a90\",\n \"code\": \"api_requests_charge\",\n \"invoice_display_name\": \"Setup\",\n \"min_amount_cents\": 0,\n \"properties\": {\n \"grouped_by\": [\n \"agent_name\"\n ],\n \"pricing_group_keys\": [\n \"agent_name\"\n ],\n \"graduated_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ],\n \"graduated_percentage_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"rate\": \"1\",\n \"flat_amount\": \"10\"\n }\n ],\n \"amount\": \"30\",\n \"free_units\": 100,\n \"package_size\": 1000,\n \"rate\": \"1\",\n \"fixed_amount\": \"0.5\",\n \"free_units_per_events\": 5,\n \"free_units_per_total_aggregation\": \"500\",\n \"per_transaction_max_amount\": \"3.75\",\n \"per_transaction_min_amount\": \"1.75\",\n \"volume_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ],\n \"presentation_group_keys\": [\n {\n \"value\": \"region\",\n \"options\": {\n \"display_in_invoice\": true\n }\n }\n ]\n },\n \"filters\": [\n {\n \"properties\": {\n \"grouped_by\": [\n \"agent_name\"\n ],\n \"pricing_group_keys\": [\n \"agent_name\"\n ],\n \"graduated_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ],\n \"graduated_percentage_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"rate\": \"1\",\n \"flat_amount\": \"10\"\n }\n ],\n \"amount\": \"30\",\n \"free_units\": 100,\n \"package_size\": 1000,\n \"rate\": \"1\",\n \"fixed_amount\": \"0.5\",\n \"free_units_per_events\": 5,\n \"free_units_per_total_aggregation\": \"500\",\n \"per_transaction_max_amount\": \"3.75\",\n \"per_transaction_min_amount\": \"1.75\",\n \"volume_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ]\n },\n \"values\": {\n \"region\": [\n \"us-east-1\"\n ]\n },\n \"invoice_display_name\": \"AWS\"\n }\n ],\n \"tax_codes\": [\n \"french_standard_vat\"\n ],\n \"applied_pricing_unit\": {\n \"conversion_rate\": \"0.5\"\n }\n }\n ],\n \"fixed_charges\": [\n {\n \"id\": \"1a901a90-1a90-1a90-1a90-1a901a901a90\",\n \"invoice_display_name\": \"Setup fee\",\n \"units\": 1,\n \"apply_units_immediately\": true,\n \"properties\": {\n \"amount\": \"30\",\n \"graduated_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ],\n \"volume_ranges\": [\n {\n \"from_value\": 0,\n \"to_value\": 10,\n \"flat_amount\": \"10\",\n \"per_unit_amount\": \"0.5\"\n }\n ]\n },\n \"tax_codes\": [\n \"french_standard_vat\"\n ]\n }\n ],\n \"usage_thresholds\": [\n {\n \"amount_cents\": 10000,\n \"threshold_display_name\": \"Threshold 1\",\n \"recurring\": true\n }\n ],\n \"metadata\": {\n \"external_id\": \"ext-123\",\n \"synced_at\": \"2024-01-15\"\n }\n },\n \"invoice_custom_section\": {\n \"skip_invoice_custom_sections\": false,\n \"invoice_custom_section_codes\": [\n \"eu_bank_details\"\n ]\n },\n \"payment_method\": {\n \"payment_method_type\": \"provider\",\n \"payment_method_id\": \"1a901a90-1a90-1a90-1a90-1a901a901a90\"\n },\n \"consolidate_invoice\": false,\n \"billing_entity_code\": \"default\",\n \"activation_rules\": [\n {\n \"type\": \"payment\",\n \"timeout_hours\": 48\n }\n ]\n },\n \"status\": \"active\"\n}")
.asString();{
"subscription": {
"lago_id": "1a901a90-1a90-1a90-1a90-1a901a901a90",
"external_id": "5eb02857-a71e-4ea2-bcf9-57d3a41bc6ba",
"lago_customer_id": "1a901a90-1a90-1a90-1a90-1a901a901a90",
"external_customer_id": "5eb02857-a71e-4ea2-bcf9-57d3a41bc6ba",
"billing_time": "anniversary",
"name": "Repository A",
"plan_code": "premium",
"status": "active",
"created_at": "2022-08-08T00:00:00Z",
"canceled_at": "2022-09-14T16:35:31Z",
"started_at": "2022-08-08T00:00:00Z",
"ending_at": "2022-10-08T00:00:00Z",
"subscription_at": "2022-08-08T00:00:00Z",
"terminated_at": "2022-09-14T16:35:31Z",
"previous_plan_code": null,
"next_plan_code": null,
"downgrade_plan_date": "2022-04-30",
"trial_ended_at": "2022-08-08T00:00:00Z",
"current_billing_period_started_at": "2022-08-08T00:00:00Z",
"current_billing_period_ending_at": "2022-09-08T00:00:00Z",
"on_termination_credit_note": "credit",
"on_termination_invoice": "generate",
"billing_entity_code": "default",
"plan_amount_cents": 10000,
"plan_amount_currency": "USD",
"applied_invoice_custom_sections": [
{
"lago_id": "1a901a90-1a90-1a90-1a90-1a901a901a90",
"created_at": "2023-07-06T14:35:58Z",
"invoice_custom_section": {
"lago_id": "1a901a90-1a90-1a90-1a90-1a901a901a90",
"name": "EU Bank Details",
"code": "eu_bank_details",
"description": "This section contains the bank details for EU customers.",
"details": "Bank Name: Nozle Bank, IBAN: FR7630004000031234567890143",
"display_name": "Bank Details:",
"applied_to_organization": true,
"organization_id": "1a901a90-1a90-1a90-1a90-1a901a901a90",
"created_at": "2023-07-06T14:35:58Z"
},
"invoice_custom_section_id": "1a901a90-1a90-1a90-1a90-1a901a901a90"
}
],
"payment_method": {
"payment_method_type": "provider",
"payment_method_id": "1a901a90-1a90-1a90-1a90-1a901a901a90"
},
"consolidate_invoice": true,
"cancellation_reason": "payment_failed",
"activated_at": "2022-08-08T00:00:00Z",
"activation_rules": [
{
"lago_id": "1a901a90-1a90-1a90-1a90-1a901a901a90",
"type": "payment",
"timeout_hours": 48,
"status": "pending",
"created_at": "2022-08-08T00:00:00Z",
"updated_at": "2022-08-08T00:00:00Z",
"expires_at": "2022-08-10T00:00:00Z"
}
]
}
}{
"status": 400,
"error": "Bad request"
}{
"status": 401,
"error": "Unauthorized"
}{
"status": 404,
"error": "Not Found",
"code": "object_not_found"
}{
"status": 422,
"error": "Unprocessable entity",
"code": "validation_errors",
"error_details": {}
}Subscriptions
Update a subscription
This endpoint allows you to update a subscription.
PUT
/
subscriptions
/
{external_id}
Update a subscription
Authorizations
Bearer authentication header of the form Bearer <token>, where <token> is your auth token.
Path Parameters
External ID of the existing subscription
Example:
"5eb02857-a71e-4ea2-bcf9-57d3a41bc6ba"
Query Parameters
By default, this endpoint only return active subscriptions. If you want to update a subscription with a different status, you can specify it here.
Available options:
active, pending Example:
"active"
Body
application/json
Update an existing subscription
Show child attributes
Show child attributes
If the field is not defined and multiple active and pending subscriptions exists, Nozle will update the active subscription. However, if you wish to update a pending subscription, please ensure that you include the status attribute with the pending value in your request body.
Available options:
active, pending Example:
"active"
Response
Subscription updated
Show child attributes
Show child attributes